<template>
  <b-overlay :show="overlayAccess" rounded="sm" variant="primary" spinner-type="" opacity="0.1" blur="2px">
   <b-overlay :show="overlay" rounded="sm" variant="primary" opacity="0.4" blur="2px">
    <ValidationObserver v-slot="{ invalid }">
      <div class="card-body">
        <div class="col-md-12">
          <b-row class="form-group mt-10">
            <b-col md="6">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  نوع قراردادهای قابل قبول
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <div class="checkbox-inline">
                    <label class="checkbox">
                      <input
                        type="checkbox"
                        name="تمام وقت"
                        :value="{value:'tamamvaght',name:'تمام وقت'}"
                        v-model="workTime"
                      />
                      <span class="mr-1"></span>
                      تمام وقت
                    </label>
                    <label class="checkbox">
                      <input
                        type="checkbox"
                        name="پاره وقت"
                        :value="{value:'parevaght',name:'پاره وقت'}"
                        v-model="workTime"
                      />
                      <span></span>
                      پاره وقت
                    </label>
                    <label class="checkbox">
                      <input
                        type="checkbox"
                        name="دورکاری"
                        :value="{value:'dorkari',name:'دورکاری'}"
                        v-model="workTime"
                      />
                      <span></span>
                      دورکاری
                    </label>
                    <label class="checkbox">
                      <input
                        type="checkbox"
                        name="کارآموزی"
                        :value="{value:'karamozi',name:'کارآموزی'}"
                        v-model="workTime"
                      />
                      <span></span>
                      کارآموزی
                    </label>
                  </div>
                </div>
              </div>
            </b-col>
            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">
                  حقوق مورد نظر
                  <span class="text-danger">*</span>
                </label>
                <div class="custom-file">
                  <ValidationProvider rules="required" v-slot="{ errors }">
                    <select class="form-control" v-model="salary" name="حقوق مورد نظر">
                      <option
                        :value="{name:'کمتر از 1 میلیون تومان',value:'less1'}"
                      >کمتر از 1 میلیون تومان</option>
                      <option
                        :value="{name:'از 1 میلیون تومان تا 2/5 میلیون تومان',value:'1to2'}"
                      >از 1 میلیون تومان تا 2/5 میلیون تومان</option>
                      <option
                        :value="{name:'از 2/5 میلیون تومان تا 3/5 میلیون تومان',value:'2to3'}"
                      >از 2/5 میلیون تومان تا 3/5 میلیون تومان</option>
                      <option
                        :value="{name:'از 3/5 میلیون تومان تا 5 میلیون تومان',value:'3to5'}"
                      >از 3/5 میلیون تومان تا 5 میلیون تومان</option>
                      <option
                        :value="{name:'بیش از 5 میلیون تومان',value:'grater5'}"
                      >بیش از 5 میلیون تومان</option>
                    </select>
                    <span class="text-danger">{{ errors[0] }}</span>
                  </ValidationProvider>
                </div>
              </div>
            </b-col>
          </b-row>
          <div class="separator separator-solid separator-border-2 separator-success my-8"></div>
          <h5 class="mb-7">شبکه های اجتماعی</h5>
          <b-row>
            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">اینستاگرام</label>
                <div class="custom-file">
                  <input
                    type="text"
                    class="form-control"
                    v-model="social.instagram"
                    placeholder="مثلا : miladk313"
                  />
                </div>
              </div>
            </b-col>
            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">تلگرام</label>
                <div class="custom-file">
                  <input
                    type="text"
                    class="form-control"
                    v-model="social.telegram"
                    placeholder="مثلا : khatkhati_ads"
                  />
                </div>
              </div>
            </b-col>
            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">لینکدین</label>
                <div class="custom-file">
                  <input
                    type="text"
                    class="form-control"
                    v-model="social.linkedin"
                    placeholder="مثلا : milad karimi"
                  />
                </div>
              </div>
            </b-col>
            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">توییتر</label>
                <div class="custom-file">
                  <input
                    type="text"
                    class="form-control"
                    v-model="social.twitter"
                    placeholder="مثلا : miladk313"
                  />
                </div>
              </div>
            </b-col>
            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">واتساپ</label>
                <div class="custom-file">
                  <input
                    type="text"
                    class="form-control"
                    v-model="social.whatsapp"
                    placeholder="مثلا : miladk313"
                  />
                </div>
              </div>
            </b-col>
            <b-col md="4">
              <div class="form-group">
                <label class="col-form-label text-lg-right text-left">بله</label>
                <div class="custom-file">
                  <input
                    type="text"
                    class="form-control"
                    v-model="social.bale"
                    placeholder="مثلا : miladk313"
                  />
                </div>
              </div>
            </b-col>
          </b-row>
        </div>
        <div class="col-md-12 mt-20">
          <div class="d-flex flex-column text-md-center">
            <span id="disabled-wrapper" tabindex="-5">
              <button
                  v-if="invalid || overlayAccess"
                type="button"
                :disabled="true"
                class="btn btn-success btn-lg btn-block"
              >ذخیره اطلاعات</button>
              <button
                v-else
                @click="nextStep()"
                type="button"
                class="btn btn-success btn-lg btn-block"
              >ذخیره اطلاعات</button>
            </span>
            <b-tooltip
              v-if="invalid"
              class="font-family: IRANYekan !important"
              target="disabled-wrapper"
            >تا زمانی که همه ی فیلد ها تکمیل نشوند این دکمه فعال نمی شود</b-tooltip>
          </div>
        </div>
      </div>
    </ValidationObserver>
  </b-overlay>
  </b-overlay>
</template>

<script>
import { ValidationObserver, ValidationProvider } from "vee-validate";
import Multiselect from "vue-multiselect";
import gql from "graphql-tag";
import addScoreJob from "~/apollo/mutation/resume/addScoreJob.gql";

export default {
  props: ["option"],
  name: "cooperation",
  components: {
    ValidationObserver,
    ValidationProvider,
    Multiselect,
  },
  data() {
    return {
      social: {},
      workTime: [],
      salary: null,
      overlay: false,
      overlayAccess: false,
    };
  },
  async mounted() {
    if (this.option) {
      if (this.option.ConfirmationStatus!=="Filling"){
        this.overlayAccess=true;
      }
      if (this.option.social) {
        delete this.option.social.__typename;
        this.social = this.option.social;
      }
      if (this.option.workTime) {
        this.option.workTime.map(
          (item) =>
            // eslint-disable-next-line no-param-reassign
            delete item.__typename
        );
        this.workTime = this.option.workTime;
      }
      if (this.option.salary) {
        delete this.option.salary.__typename;
        this.salary = this.option.salary;
      }
    }
  },
  methods: {
    nextStep() {
      if (this.workTime.length === 0) {
        Swal.fire({
          title: "عدم مشخص کردن نوع قرارداد",
          text: "لطفا حداقل یک مورد را انتخاب کنید",
          icon: "warning",
          confirmButtonText: "باشه",
        });
      } else {
        Swal.fire({
          title: "تایید نهایی",
          text: "پس از تایید نهایی امکان ویرایش وجود ندارد!",
          icon: "warning",
          confirmButtonText: "باشه",
          cancelButtonText: "انصراف",
          showCancelButton: true,
        }).then((res) => {
          res.isConfirmed ? this.saveWorkTimeAndSalary() : "";
        });
      }
    },

    async saveWorkTimeAndSalary() {
      let self = this;
      self.overlay = true;
      let variables = {
        id: this.option.id,
        social: JSON.stringify(self.social),
        workTime: JSON.stringify(self.workTime),
        salary: JSON.stringify(self.salary),
      };
      let mutation = gql`
        ${addScoreJob}
      `;
      await this.$apollo
        .mutate({
          mutation,
          variables,
          context: { headers: { "x-token": this.$auth.getToken("local") } },
        })
        .then(({ data }) => {
          self.overlay = false;
          Swal.close();
          if (data.addScoreJob != null) {
            this.overlayAccess=true;
            Swal.fire({
              title: "موفقیت آمیز",
              text: "اطلاعات با موفقیت ثبت شد.",
              icon: "success",
              confirmButtonText: "باشه",
            }).then((res) => {
              this.$emit("my-event", {
                step: "cooperation",
                social: self.social,
                workTime: self.workTime,
                salary: self.salary,
              });
            });
          }
        })
        .catch((err) => {
          self.overlay = false;
          Swal.close();
          let gqlError = err.graphQLErrors;
          if (gqlError.length > 0) {
            if (err.graphQLErrors[0].extensions.code == "UNAUTHENTICATED") {
              let self = this;
              console.log("please login");
              /* this.$auth.logout().then(res => {
                   self.$router.push("/login");
                 });*/
            }
          } else {
            Swal.fire({
              title: "خطا",
              text:
                "مشکل در ارتباط، لطفا اتصال اینترنت خود را بررسی و سپس مجددا تلاش کنید",
              icon: "error",
              confirmButtonText: "باشه",
            });
          }
        });
    },
  },
};
</script>

<style scoped>
</style>